## ros-rolling-rclpy 3.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclpy)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()
# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

# Figure out Python3 debug/release before anything else can find_package it
if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  find_package(python_cmake_module REQUIRED)
  find_package(PythonExtra REQUIRED)

  # Force FindPython3 to use the debug interpreter where ROS 2 expects it
  set(Python3_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rcl_logging_interface REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

# Find python before pybind11
find_package(Python3 REQUIRED COMPONENTS Interpreter Development)

find_package(pybind11_vendor REQUIRED)
find_package(pybind11 REQUIRED)

# enables using the Python extensions from the build space for testing
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/test_rclpy/__init__.py" "")

ament_python_install_package(${PROJECT_NAME})

# Only build the library if a C typesupport exists
get_rmw_typesupport(typesupport_impls "rmw_implementation" LANGUAGE "c")
if(typesupport_impls STREQUAL "")
  message(STATUS "Skipping rclpy because no C typesupport library was found.")
  return()
endif()

# Set the build location and install location for a CPython extension
function(configure_build_install_location _library_name)
  # Install into test_rclpy folder in build space for unit tests to import
  set_target_properties(${_library_name} PROPERTIES
    # Use generator expression to avoid prepending a build type specific directory on Windows
    LIBRARY_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test_rclpy>
    RUNTIME_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test_rclpy>)

  # Install library for actual use
  install(TARGETS ${_library_name}
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}"
  )
endfunction()

# Split from main extension and converted to pybind11
pybind11_add_module(_rclpy_pybind11 SHARED
  src/rclpy/_rclpy_logging.cpp
  src/rclpy/_rclpy_pybind11.cpp
  src/rclpy/action_client.cpp
  src/rclpy/action_goal_handle.cpp
  src/rclpy/action_server.cpp
  src/rclpy/client.cpp
  src/rclpy/clock.cpp
  src/rclpy/context.cpp
  src/rclpy/destroyable.cpp
  src/rclpy/duration.cpp
  src/rclpy/clock_event.cpp
  src/rclpy/exceptions.cpp
  src/rclpy/graph.cpp
  src/rclpy/guard_condition.cpp
  src/rclpy/lifecycle.cpp
  src/rclpy/logging.cpp
  src/rclpy/names.cpp
  src/rclpy/node.cpp
  src/rclpy/publisher.cpp
  src/rclpy/qos.cpp
  src/rclpy/qos_event.cpp
  src/rclpy/serialization.cpp
  src/rclpy/service.cpp
  src/rclpy/service_info.cpp
  src/rclpy/signal_handler.cpp
  src/rclpy/subscription.cpp
  src/rclpy/time_point.cpp
  src/rclpy/timer.cpp
  src/rclpy/utils.cpp
  src/rclpy/wait_set.cpp
)
target_include_directories(_rclpy_pybind11 PRIVATE
  src/rclpy/
)
target_link_libraries(_rclpy_pybind11 PRIVATE
  lifecycle_msgs::lifecycle_msgs__rosidl_generator_c
  lifecycle_msgs::lifecycle_msgs__rosidl_typesupport_c
  rcl::rcl
  rcl_action::rcl_action
  rcl_lifecycle::rcl_lifecycle
  rcl_logging_interface::rcl_logging_interface
  rcpputils::rcpputils
  rcutils::rcutils
)
configure_build_install_location(_rclpy_pybind11)

if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
  )
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS rcutils::rcutils INTERFACE_INCLUDE_DIRECTORIES)
  list(APPEND AMENT_LINT_AUTO_EXCLUDE "ament_cmake_cppcheck")
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_cppcheck REQUIRED)
  ament_cppcheck()
  set_tests_properties(cppcheck PROPERTIES TIMEOUT 420)

  find_package(ament_cmake_pytest REQUIRED)
  find_package(rosidl_generator_py REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)

  rosidl_generator_py_get_typesupports(_typesupport_impls)
  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()

  ament_add_gtest(test_python_allocator
    test/test_python_allocator.cpp)
  target_include_directories(test_python_allocator PRIVATE src/rclpy)
  target_link_libraries(test_python_allocator pybind11::embed)

  if(NOT _typesupport_impls STREQUAL "")
    # Run each test in its own pytest invocation to isolate any global state in rclpy
    set(_rclpy_pytest_tests
      test/test_action_client.py
      test/test_action_graph.py
      test/test_action_server.py
      test/test_callback_group.py
      test/test_client.py
      test/test_clock.py
      test/test_context.py
      test/test_create_node.py
      test/test_create_while_spinning.py
      test/test_destruction.py
      test/test_executor.py
      test/test_expand_topic_name.py
      test/test_guard_condition.py
      test/test_init_shutdown.py
      test/test_logging.py
      test/test_logging_rosout.py
      test/test_messages.py
      test/test_node.py
      test/test_parameter.py
      test/test_publisher.py
      test/test_qos.py
      test/test_qos_event.py
      test/test_qos_overriding_options.py
      test/test_rate.py
      test/test_serialization.py
      test/test_subscription.py
      test/test_task.py
      test/test_time_source.py
      test/test_time.py
      test/test_timer.py
      test/test_topic_or_service_is_hidden.py
      test/test_topic_endpoint_info.py
      test/test_type_support.py
      test/test_utilities.py
      test/test_validate_full_topic_name.py
      test/test_validate_namespace.py
      test/test_validate_node_name.py
      test/test_validate_topic_name.py
      test/test_waitable.py
    )

    foreach(_test_path ${_rclpy_pytest_tests})
      get_filename_component(_test_name ${_test_path} NAME_WE)
      ament_add_pytest_test(${_test_name} ${_test_path}
        APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}
          PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}
        TIMEOUT 120
        WERROR ON
      )
    endforeach()
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-rolling-rclpy (3.2.1-1focal) focal; urgency=high

  * Fix multi-threaded race condition in client.call_async (#871 <https://github.com/ros2/rclpy/issues/871>)
  * Fix include order for cpplint (#877 <https://github.com/ros2/rclpy/issues/877>)
  * Bugfix/duration to msg precision (#876 <https://github.com/ros2/rclpy/issues/876>)
  * Update to pybind11 2.7.1 (#874 <https://github.com/ros2/rclpy/issues/874>)
  * QoS history depth is only available with KEEP_LAST (#869 <https://github.com/ros2/rclpy/issues/869>)
  * Contributors: Auguste Lalande, Chris Lalancette, Erki Suurjaak, Jacob Perron, Tomoya Fujita

 -- Shane Loretz <sloretz@openrobotics.org>  Fri, 14 Jan 2022 08:00:00 -0000

ros-rolling-rclpy (3.2.0-1focal) focal; urgency=high

  * Implement managed nodes. (#865 <https://github.com/ros2/rclpy/issues/865>)
  * Make rclpy.try_shutdown() behavior to follow rclpy.shutdown() more closely. (#868 <https://github.com/ros2/rclpy/issues/868>)
  * Update TopicEndpointTypeEnum.__str__() method to include history kind and history depth. (#849 <https://github.com/ros2/rclpy/issues/849>)
  * Add Clock.sleep_for() using Clock.sleep_until(). (#864 <https://github.com/ros2/rclpy/issues/864>)
  * Add Clock.sleep_until() (#858 <https://github.com/ros2/rclpy/issues/858>)
  * Add __enter__ and __exit__ to JumpHandle. (#862 <https://github.com/ros2/rclpy/issues/862>)
  * Don't override rclpy._rclpy_pybind11 docs. (#863 <https://github.com/ros2/rclpy/issues/863>)
  * Improve JumpThreshold documentation and forbid zero durations. (#861 <https://github.com/ros2/rclpy/issues/861>)
  * Fix time.py and clock.py circular import. (#860 <https://github.com/ros2/rclpy/issues/860>)
  * Make context.on_shutdown() allow free functions. (#859 <https://github.com/ros2/rclpy/issues/859>)
  * Fix automatically declared parameters descriptor type. (#853 <https://github.com/ros2/rclpy/issues/853>)
  * Shutdown asynchronously when sigint is received. (#844 <https://github.com/ros2/rclpy/issues/844>)
  * Update maintainers. (#845 <https://github.com/ros2/rclpy/issues/845>)
  * Add entities to callback group before making them available to the executor to avoid a race condition. (#839 <https://github.com/ros2/rclpy/issues/839>)
  * Avoid race condition in client.call(). (#838 <https://github.com/ros2/rclpy/issues/838>)
  * Contributors: Ivan Santiago Paunovic, Jacob Perron, Shane Loretz, Tomoya Fujita

 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 23 Dec 2021 08:00:00 -0000

ros-rolling-rclpy (3.1.0-1focal) focal; urgency=high

  * Handle sigterm. (#830 <https://github.com/ros2/rclpy/issues/830>)
  * Use pybind11 for signal handling, and delete now unused rclpy_common, pycapsule, and handle code. (#814 <https://github.com/ros2/rclpy/issues/814>)
  * Fix memory leak in Service::take_request() and Client::take_response(). (#828 <https://github.com/ros2/rclpy/issues/828>)
  * Add Publisher.wait_for_all_acked(). (#793 <https://github.com/ros2/rclpy/issues/793>)
  * Only add one done callback to a future in Executor. (#816 <https://github.com/ros2/rclpy/issues/816>)
  * Add convert function from ParameterValue to Python builtin. (#819 <https://github.com/ros2/rclpy/issues/819>)
  * Call Context._logging_fini() in Context.try_shutdown(). (#800 <https://github.com/ros2/rclpy/issues/800>)
  * Lift LoggingSeverity enum as common dependency to logging and rcutils_logger modules (#785 <https://github.com/ros2/rclpy/issues/785>)
  * Set Context.__context to None in __init__(). (#812 <https://github.com/ros2/rclpy/issues/812>)
  * Remove unused function make_mock_subscription. (#809 <https://github.com/ros2/rclpy/issues/809>)
  * Contributors: Barry Xu, Chris Lalancette, Ivan Santiago Paunovic, Jacob Perron, Lei Liu, Louise Poubel, Shane Loretz, ksuszka

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 22 Oct 2021 07:00:00 -0000

ros-rolling-rclpy (3.0.1-1focal) focal; urgency=high

  * Removed common.c/h (#789 <https://github.com/ros2/rclpy/issues/789>)
  * Contributors: Alejandro Hernández Cordero

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 11 Jun 2021 07:00:00 -0000

ros-rolling-rclpy (3.0.0-1focal) focal; urgency=high

  * Allow declaring uninitialized parameters (#798 <https://github.com/ros2/rclpy/issues/798>)
  * Reject cancel request if failed to transit to CANCEL_GOAL state (#791 <https://github.com/ros2/rclpy/issues/791>)
  * Deleted handle as it should no longer be used (#786 <https://github.com/ros2/rclpy/issues/786>)
  * Removed some functions in common.c and replaced them in utils.cpp (#787 <https://github.com/ros2/rclpy/issues/787>)
  * Moved exception.cpp/hpp to the _rclpy_pybind11 module (#788 <https://github.com/ros2/rclpy/issues/788>)
  * Contributors: Alejandro Hernández Cordero, Jacob Perron, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 19 May 2021 07:00:00 -0000

ros-rolling-rclpy (2.0.0-1focal) focal; urgency=high

  * Print 'Infinite' for infinite durations in topic endpoint info (#722 <https://github.com/ros2/rclpy/issues/722>)
  * Break log function execution ASAP if configured severity is too high (#776 <https://github.com/ros2/rclpy/issues/776>)
  * Convert Node and Context to use C++ Classes (#771 <https://github.com/ros2/rclpy/issues/771>)
  * Misc action server improvements (#774 <https://github.com/ros2/rclpy/issues/774>)
  * Misc action goal handle improvements (#767 <https://github.com/ros2/rclpy/issues/767>)
  * Convert Guardcondition to use C++ classes (#772 <https://github.com/ros2/rclpy/issues/772>)
  * Removed unused structs ``rclpy_client_t`` and ``rclpy_service_t`` (#770 <https://github.com/ros2/rclpy/issues/770>)
  * Convert WaitSet to use C++ Classes (#769 <https://github.com/ros2/rclpy/issues/769>)
  * Convert ActionServer to use C++ Classes (#766 <https://github.com/ros2/rclpy/issues/766>)
  * Convert ActionClient to use C++ classes (#759 <https://github.com/ros2/rclpy/issues/759>)


=== debian/control ===
Source: ros-rolling-rclpy
Section: misc
Priority: optional
Maintainer: Shane Loretz <sloretz@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), python3-pytest, ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest, ros-rolling-ament-cmake-pytest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-pybind11-vendor, ros-rolling-python-cmake-module, ros-rolling-rcl, ros-rolling-rcl-action, ros-rolling-rcl-lifecycle, ros-rolling-rcl-logging-interface, ros-rolling-rcl-yaml-param-parser, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw-implementation, ros-rolling-rmw-implementation-cmake, ros-rolling-rosidl-generator-py, ros-rolling-test-msgs, ros-rolling-unique-identifier-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rclpy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ament-index-python, ros-rolling-builtin-interfaces, ros-rolling-rcl, ros-rolling-rcl-action, ros-rolling-rcl-interfaces, ros-rolling-rcl-lifecycle, ros-rolling-rcl-logging-interface, ros-rolling-rcl-yaml-param-parser, ros-rolling-rmw-implementation, ros-rolling-rosgraph-msgs, ros-rolling-rpyutils, ros-rolling-unique-identifier-msgs, ros-rolling-ros-workspace
Description: Package containing the Python client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rclpy//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rclpy 5.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 # Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
   set(CMAKE_CXX_STANDARD 17)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
 endif()
 # Default to C11
 if(NOT CMAKE_C_STANDARD)
@@ -28,6 +29,7 @@
 find_package(lifecycle_msgs REQUIRED)
 find_package(rcl REQUIRED)
 find_package(rcl_action REQUIRED)
+find_package(rcl_interfaces REQUIRED)
 find_package(rcl_lifecycle REQUIRED)
 find_package(rcl_logging_interface REQUIRED)
 find_package(rcl_yaml_param_parser REQUIRED)
@@ -35,6 +37,7 @@
 find_package(rcutils REQUIRED)
 find_package(rmw REQUIRED)
 find_package(rmw_implementation_cmake REQUIRED)
+find_package(rosidl_runtime_c REQUIRED)
 
 # Find python before pybind11
 find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
@@ -90,17 +93,24 @@
   src/rclpy/node.cpp
   src/rclpy/publisher.cpp
   src/rclpy/qos.cpp
-  src/rclpy/qos_event.cpp
+  src/rclpy/event_handle.cpp
   src/rclpy/serialization.cpp
   src/rclpy/service.cpp
   src/rclpy/service_info.cpp
+  src/rclpy/service_introspection.cpp
   src/rclpy/signal_handler.cpp
   src/rclpy/subscription.cpp
   src/rclpy/time_point.cpp
   src/rclpy/timer.cpp
+  src/rclpy/type_description_service.cpp
   src/rclpy/utils.cpp
   src/rclpy/wait_set.cpp
 )
+
+if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND NOT APPLE)
+  target_link_libraries(_rclpy_pybind11 PRIVATE atomic)
+endif()
+
 target_include_directories(_rclpy_pybind11 PRIVATE
   src/rclpy/
 )
@@ -109,10 +119,12 @@
   lifecycle_msgs::lifecycle_msgs__rosidl_typesupport_c
   rcl::rcl
   rcl_action::rcl_action
+  ${rcl_interfaces_TARGETS}
   rcl_lifecycle::rcl_lifecycle
   rcl_logging_interface::rcl_logging_interface
   rcpputils::rcpputils
   rcutils::rcutils
+  rosidl_runtime_c::rosidl_runtime_c
 )
 configure_build_install_location(_rclpy_pybind11)
 
@@ -170,15 +182,21 @@
       test/test_init_shutdown.py
       test/test_logging.py
       test/test_logging_rosout.py
+      test/test_logging_service.py
       test/test_messages.py
       test/test_node.py
       test/test_parameter.py
+      test/test_parameter_client.py
+      test/test_parameter_service.py
       test/test_publisher.py
       test/test_qos.py
       test/test_qos_event.py
       test/test_qos_overriding_options.py
       test/test_rate.py
+      test/test_rosout_subscription.py
       test/test_serialization.py
+      test/test_service.py
+      test/test_service_introspection.py
       test/test_subscription.py
       test/test_task.py
       test/test_time_source.py
@@ -187,12 +205,14 @@
       test/test_topic_or_service_is_hidden.py
       test/test_topic_endpoint_info.py
       test/test_type_support.py
+      test/test_type_hash.py
       test/test_utilities.py
       test/test_validate_full_topic_name.py
       test/test_validate_namespace.py
       test/test_validate_node_name.py
       test/test_validate_topic_name.py
       test/test_waitable.py
+      test/test_wait_for_message.py
     )
 
     foreach(_test_path ${_rclpy_pytest_tests})

=== debian/changelog ===
ros-rolling-rclpy (5.2.0-1jammy) jammy; urgency=high

  * add list_parameters & test (#1124 <https://github.com/ros2/rclpy/issues/1124>)
  * Contributors: Minju, Lee

 -- Shane Loretz <sloretz@openrobotics.org>  Fri, 08 Sep 2023 00:00:00 -0000

ros-rolling-rclpy (5.1.0-1jammy) jammy; urgency=high

  * Support to get remapped service name (#1156 <https://github.com/ros2/rclpy/issues/1156>)
  * a couple of typo fixes. (#1158 <https://github.com/ros2/rclpy/issues/1158>)
  * Fix get_type_description service bug and add a unit test (#1155 <https://github.com/ros2/rclpy/issues/1155>)
  * Fix an inherent race in execution vs. destruction. (#1150 <https://github.com/ros2/rclpy/issues/1150>)
  * Cleanup of test_node.py. (#1153 <https://github.com/ros2/rclpy/issues/1153>)
  * Contributors: Barry Xu, Chris Lalancette, Emerson Knapp, Tomoya Fujita

 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 07 Sep 2023 00:00:00 -0000

ros-rolling-rclpy (5.0.1-1jammy) jammy; urgency=high

  * Avoid generating the exception when rcl_send_response times out. (#1136 <https://github.com/ros2/rclpy/issues/1136>)
  * Store time source clocks in a set (#1146 <https://github.com/ros2/rclpy/issues/1146>)
  * Fix spin_once_until_future_complete to quit when the future finishes. (#1143 <https://github.com/ros2/rclpy/issues/1143>)
  * Contributors: Chris Lalancette, Luca Della Vedova, Tomoya Fujita

 -- Shane Loretz <sloretz@openrobotics.org>  Mon, 21 Aug 2023 00:00:00 -0000

ros-rolling-rclpy (5.0.0-1jammy) jammy; urgency=high

  * get_type_description service (#1139 <https://github.com/ros2/rclpy/issues/1139>)
  * Add in the ability to start timers paused. (#1138 <https://github.com/ros2/rclpy/issues/1138>)
  * Modifies ros_timer_init for ros_timer_init2 (#999 <https://github.com/ros2/rclpy/issues/999>)
  * Fix/param namespace association 894 (#1132 <https://github.com/ros2/rclpy/issues/1132>)
  * Include type hash in topic endpoint info (#1104 <https://github.com/ros2/rclpy/issues/1104>)
  * Contributors: Chris Lalancette, Eloy Briceno, Emerson Knapp, Hans-Joachim Krauch, M. Hofstätter

 -- Shane Loretz <sloretz@openrobotics.org>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-rclpy (4.2.2-1jammy) jammy; urgency=high

  * Fix iteration over modified list (#1129 <https://github.com/ros2/rclpy/issues/1129>)
  * making optional things Optional (#974 <https://github.com/ros2/rclpy/issues/974>)
  * Fix type signature of Client.wait_for_service (#1128 <https://github.com/ros2/rclpy/issues/1128>)
  * Contributors: Brian, Felix Divo

 -- Shane Loretz <sloretz@openrobotics.org>  Wed, 07 Jun 2023 00:00:00 -0000

ros-rolling-rclpy (4.2.1-1jammy) jammy; urgency=high

  * Fix action server crash when the client goes away. (#1114 <https://github.com/ros2/rclpy/issues/1114>)
  * Turn Executor into a ContextManager (#1118 <https://github.com/ros2/rclpy/issues/1118>)
  * Turn Context into a ContextManager (#1117 <https://github.com/ros2/rclpy/issues/1117>)
  * Fix type in Node init args (#1115 <https://github.com/ros2/rclpy/issues/1115>)
  * Contributors: Chris Lalancette, Felix Divo, Russ

 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 11 May 2023 00:00:00 -0000

ros-rolling-rclpy (4.2.0-1jammy) jammy; urgency=high



 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 27 Apr 2023 00:00:00 -0000

ros-rolling-rclpy (4.1.0-1jammy) jammy; urgency=high

  * Logging service support (#1102 <https://github.com/ros2/rclpy/issues/1102>)
  * Use custom sourcedir for conf.py (#1109 <https://github.com/ros2/rclpy/issues/1109>)
  * ServerGoalHandle should be destroyed before removing. (#1113 <https://github.com/ros2/rclpy/issues/1113>)
  * Fix unnecessary list comprehension flake8 (#1112 <https://github.com/ros2/rclpy/issues/1112>)
  * Contributors: Barry Xu, Michael Carroll, Tomoya Fujita, Yadu

 -- Shane Loretz <sloretz@openrobotics.org>  Tue, 18 Apr 2023 00:00:00 -0000

ros-rolling-rclpy (4.0.0-1jammy) jammy; urgency=high

  * Stub type hash value line in TopicEndpointInfo string (#1110 <https://github.com/ros2/rclpy/issues/1110>)
  * Support documentation generation using rosdoc2 (#1103 <https://github.com/ros2/rclpy/issues/1103>)
  * Fix Time and Duration raising exception when compared to another type (#1007 <https://github.com/ros2/rclpy/issues/1007>)
  * Make rcl_interfaces a build and exec dependency. (#1100 <https://github.com/ros2/rclpy/issues/1100>)
  * Solving Atomic undefined on OSX with clang (#1096 <https://github.com/ros2/rclpy/issues/1096>)
  * Implement matched event (#1083 <https://github.com/ros2/rclpy/issues/1083>)
  * Update service.py documentation (#1094 <https://github.com/ros2/rclpy/issues/1094>)
  * Allow space or empty strings when using ros2 param set (#1093 <https://github.com/ros2/rclpy/issues/1093>)
  * Hook up the incompatible type event inside of rclpy (#1058 <https://github.com/ros2/rclpy/issues/1058>)
  * Switch to using module instead of module_ (#1090 <https://github.com/ros2/rclpy/issues/1090>)
  * Add in subscription.get_publisher_count() (#1089 <https://github.com/ros2/rclpy/issues/1089>)
  * Contributors: Barry Xu, Chris Lalancette, Emerson Knapp, Erki Suurjaak, Felix Divo, GuiHome, Lucas Wendland, Yadu

 -- Shane Loretz <sloretz@openrobotics.org>  Wed, 12 Apr 2023 00:00:00 -0000

ros-rolling-rclpy (3.10.0-1jammy) jammy; urgency=high

  * Service introspection (#988 <https://github.com/ros2/rclpy/issues/988>)
  * Contributors: Brian

 -- Shane Loretz <sloretz@openrobotics.org>  Wed, 01 Mar 2023 00:00:00 -0000

ros-rolling-rclpy (3.9.0-1jammy) jammy; urgency=high

  * to create a sublogger while getting child of Logger (#1084 <https://github.com/ros2/rclpy/issues/1084>)
  * Fix #983 <https://github.com/ros2/rclpy/issues/983> by saving future and checking for + raising any exceptions (#1073 <https://github.com/ros2/rclpy/issues/1073>)
  * Contributors: Achille Verheye, Chen Lihui

 -- Shane Loretz <sloretz@openrobotics.org>  Fri, 24 Feb 2023 00:00:00 -0000



=== debian/control ===
Source: ros-rolling-rclpy
Section: misc
Priority: optional
Maintainer: Shane Loretz <sloretz@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), python3-pytest <!nocheck>, ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-cmake-pytest <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-lifecycle-msgs, ros-rolling-pybind11-vendor, ros-rolling-python-cmake-module, ros-rolling-rcl, ros-rolling-rcl-action, ros-rolling-rcl-interfaces, ros-rolling-rcl-lifecycle, ros-rolling-rcl-logging-interface, ros-rolling-rcl-yaml-param-parser, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-implementation, ros-rolling-rmw-implementation-cmake, ros-rolling-rosidl-generator-py <!nocheck>, ros-rolling-rosidl-runtime-c, ros-rolling-test-msgs <!nocheck>, ros-rolling-unique-identifier-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rclpy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-action-msgs, ros-rolling-ament-index-python, ros-rolling-builtin-interfaces, ros-rolling-lifecycle-msgs, ros-rolling-rcl, ros-rolling-rcl-action, ros-rolling-rcl-interfaces, ros-rolling-rcl-lifecycle, ros-rolling-rcl-logging-interface, ros-rolling-rcl-yaml-param-parser, ros-rolling-rmw, ros-rolling-rmw-implementation, ros-rolling-rosgraph-msgs, ros-rolling-rosidl-runtime-c, ros-rolling-rpyutils, ros-rolling-unique-identifier-msgs, ros-rolling-ros-workspace
Description: Package containing the Python client.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
